Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 2730)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 2731)
@@ -1265,34 +1360,34 @@
 		// expand selection
 		if (ids == null) return;
 		if (ids.length == 0) return;
-		//TODO: enable the feature for Windows computers
-		//if (System.getProperty("os.name").toLowerCase().contains("windows")) return; 
+		// TODO: enable the feature for Windows computers
+		// if (System.getProperty("os.name").toLowerCase().contains("windows")) return;
 		
-		//this.getBrowser().evaluate("alert('expand selection');");
-		//System.out.println("EXPAND SELECTION TO "+Arrays.toString(ids));
+		// this.getBrowser().evaluate("alert('expand selection');");
+		// System.out.println("EXPAND SELECTION TO "+Arrays.toString(ids));
 		String id1 = ids[0];
 		String id2 = ids[1];
 		if (id2 == null) id2 = id1;
 		String SCRIPT02_expand = ""
-				+ "var elt = document.getElementById(\""+id1+"\");\n" //$NON-NLS-1$ //$NON-NLS-2$
-				+ "var elt2 = document.getElementById(\""+id2+"\");\n" //$NON-NLS-1$ //$NON-NLS-2$
-				//+ "alert(\"elt=\"+elt);\n"
+				+ "var elt = document.getElementById(\"" + id1 + "\");\n" //$NON-NLS-1$ //$NON-NLS-2$
+				+ "var elt2 = document.getElementById(\"" + id2 + "\");\n" //$NON-NLS-1$ //$NON-NLS-2$
+				// + "alert(\"elt=\"+elt);\n"
 				+ "var sel = txmGetSelection();\n" //$NON-NLS-1$
-				//+ "alert(\"sel=\"+sel.extentNode);\n"
-				//+ "alert(\"typeof sel=\"+Object.getOwnPropertyNames(sel));\n"
-				//+ "alert(\"get_type sel=\"+get_type(sel));\n"
+				// + "alert(\"sel=\"+sel.extentNode);\n"
+				// + "alert(\"typeof sel=\"+Object.getOwnPropertyNames(sel));\n"
+				// + "alert(\"get_type sel=\"+get_type(sel));\n"
 				+ "var range = txmGetRange(sel, 0);\n" //$NON-NLS-1$
-				//+ "alert(\"range=\"+range);\n"
-				//+ "alert(\"typeof range=\"+Object.getOwnPropertyNames(range));\n"
-				//+ "alert(\"get_type range=\"+get_type(range));\n"
-				+"range.setStart(elt, 0);\n" //$NON-NLS-1$
-				+"range.setEndAfter(elt2, 0);\n" //$NON-NLS-1$
-				+"sel.removeAllRanges();\n" //$NON-NLS-1$
-				+"sel.addRange(range);\n" //$NON-NLS-1$
+				// + "alert(\"range=\"+range);\n"
+				// + "alert(\"typeof range=\"+Object.getOwnPropertyNames(range));\n"
+				// + "alert(\"get_type range=\"+get_type(range));\n"
+				+ "range.setStart(elt, 0);\n" //$NON-NLS-1$
+				+ "range.setEndAfter(elt2, 0);\n" //$NON-NLS-1$
+				+ "sel.removeAllRanges();\n" //$NON-NLS-1$
+				+ "sel.addRange(range);\n" //$NON-NLS-1$
 				+ "\n" //$NON-NLS-1$
 				+ "return null;"; //$NON-NLS-1$
-		
-		//System.out.println("Eval...\n"+SCRIPT02_expand);
+				
+		// System.out.println("Eval...\n"+SCRIPT02_expand);
 		evaluate(SCRIPT02_expand);
 		return;
 	}
@@ -1323,10 +1418,10 @@
 	public void removeHighlightWords() {
 		
 		// FIXME: SJ: this code leads to a concurrency modification exception on Windows
-		//		Set<String> keys = highlightedColorPerWordIDS.keySet();
-		//		for (String key : keys) {
-		//			highlightedColorPerWordIDS.remove(key);
-		//		}
+		// Set<String> keys = highlightedColorPerWordIDS.keySet();
+		// for (String key : keys) {
+		// highlightedColorPerWordIDS.remove(key);
+		// }
 		
 		// SJ: new version tests
 		highlightedColorPerWordIDS.clear();
@@ -1334,4 +1429,4 @@
 		
 		
 	}
-}
\ No newline at end of file
+}
Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java	(revision 2730)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditionEditor.java	(revision 2731)
@@ -72,12 +72,14 @@
 import org.eclipse.ui.PlatformUI;
 import org.eclipse.ui.commands.ICommandService;
 import org.eclipse.ui.handlers.IHandlerService;
+import org.txm.core.results.TXMResult;
 import org.txm.edition.rcp.messages.EditionUIMessages;
 import org.txm.objects.Edition;
 import org.txm.objects.Page;
 import org.txm.objects.Text;
 import org.txm.rcp.IImageKeys;
 import org.txm.rcp.editors.IEditionEditor;
+import org.txm.rcp.editors.ITXMResultEditor;
 import org.txm.rcp.editors.TXMEditor;
 import org.txm.rcp.swt.GLComposite;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionSelectorDialog.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionSelectorDialog.java	(revision 2730)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionSelectorDialog.java	(revision 2731)
@@ -12,35 +12,36 @@
 import org.txm.objects.CorpusBuild;
 
 public class EditionSelectorDialog extends ElementListSelectionDialog {
-
+	
 	public EditionSelectorDialog(Shell parent, CorpusBuild corpus, List<String> defaultSelection) {
 		super(parent, new ILabelProvider() {
+			
 			@Override
-			public void removeListener(ILabelProviderListener listener) { }
-
+			public void removeListener(ILabelProviderListener listener) {}
+			
 			@Override
 			public boolean isLabelProperty(Object element,
 					String property) {
 				return false;
 			}
-
+			
 			@Override
-			public void dispose() { }
-
+			public void dispose() {}
+			
 			@Override
-			public void addListener(ILabelProviderListener listener) { }
-
+			public void addListener(ILabelProviderListener listener) {}
+			
 			@Override
 			public Image getImage(Object element) {
 				return null;
 			}
-
+			
 			@Override
 			public String getText(Object element) {
 				return element.toString();
 			}
 		});
-
+		
 		setTitle(EditionUIMessages.editions);
 		setMessage(EditionUIMessages.selectOneOrMoreEditions);
 		setMultipleSelection(true);
@@ -49,8 +50,8 @@
 		setFilter("*"); //$NON-NLS-1$
 		
 		if (defaultSelection == null) {
-			defaultSelection = Arrays.asList(corpus.getProject().getDefaultEdition());
+			defaultSelection = Arrays.asList(corpus.getProject().getDefaultEditionName());
 		}
 		this.setInitialSelections(defaultSelection.toArray());
 	}
-}
\ No newline at end of file
+}
Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditorInput.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditorInput.java	(revision 2730)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/SynopticEditorInput.java	(revision 2731)
@@ -15,10 +15,11 @@
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
 
 public class SynopticEditorInput extends TXMResultEditorInput<Text> implements IEditorInput {
-
+	
 	private CQPCorpus corpus;
+	
 	private List<String> editions;
-
+	
 	/**
 	 * Instantiates a new SynopticEditorInput
 	 *
@@ -32,19 +33,20 @@
 		this.corpus = corpus;
 		this.editions = editions;
 		
-//		if (text == null) {
-//			this.text = corpus.getProject().getFirstText();
-//		} else {
-//			this.text = corpus.getProject().getText(text);
-//		}
+		// if (text == null) {
+		// this.text = corpus.getProject().getFirstText();
+		// } else {
+		// this.text = corpus.getProject().getText(text);
+		// }
 		
 		if (editions == null) {
-			String[] defaultEditions = {corpus.getProject().getDefaultEdition()};
+			String[] defaultEditions = { corpus.getProject().getDefaultEditionName() };
 			this.editions = Arrays.asList(defaultEditions);
 		}
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.IEditorInput#getImageDescriptor()
 	 */
 	@Override
@@ -52,39 +54,43 @@
 		return AbstractUIPlugin.imageDescriptorFromPlugin(
 				Application.PLUGIN_ID, IImageKeys.EDITION);
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.IEditorInput#getName()
 	 */
 	@Override
 	public String getName() {
-		return corpus.getName()+ " - "+getResult()+ " - "+editions;  //$NON-NLS-1$ //$NON-NLS-2$
+		return corpus.getName() + " - " + getResult() + " - " + editions;  //$NON-NLS-1$ //$NON-NLS-2$
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.IEditorInput#getPersistable()
 	 */
 	@Override
 	public IPersistableElement getPersistable() {
 		return null;
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.IEditorInput#getToolTipText()
 	 */
 	@Override
 	public String getToolTipText() {
 		return getName();
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.core.runtime.IAdaptable#getAdapter(java.lang.Class)
 	 */
 	@Override
 	public Object getAdapter(Class adapter) {
 		return null;
 	}
-
+	
 	/**
 	 * Gets the corpus.
 	 *
@@ -93,7 +99,7 @@
 	public CQPCorpus getCorpus() {
 		return corpus;
 	}
-
+	
 	public Text getText() {
 		return getResult();
 	}
@@ -101,8 +107,9 @@
 	public List<String> getEditions() {
 		return editions;
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see org.eclipse.ui.IEditorInput#exists()
 	 */
 	@Override
Index: tmp/org.txm.links.rcp/src/org/txm/links/rcp/handlers/SendSelectionToQueryable.java
===================================================================
--- tmp/org.txm.links.rcp/src/org/txm/links/rcp/handlers/SendSelectionToQueryable.java	(revision 2730)
+++ tmp/org.txm.links.rcp/src/org/txm/links/rcp/handlers/SendSelectionToQueryable.java	(revision 2731)
@@ -33,9 +33,9 @@
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.txm.core.preferences.TXMPreferences;
 import org.txm.core.results.TXMResult;
+import org.txm.links.rcp.messages.Messages;
 import org.txm.rcp.handlers.BaseAbstractHandler;
 import org.txm.utils.logger.Log;
-import org.txm.links.rcp.messages.Messages;
 
 /**
  * Base command to send a selection to a command that needs one or more queries to compute the new result.
@@ -89,7 +89,7 @@
 			TXMPreferences.put(resultParametersNodePath, TXMPreferences.QUERIES, queries);
 			
 			BaseAbstractHandler.executeSendToCommand(event.getCommand().getId(), resultParametersNodePath);
-			
+			// TODO we should test if there is already a linked editor and used it. Do to it we must either A) know which editor class is must be opened B) know why a previous editor has been open
 		}
 		else {
 			this.logCanNotExecuteCommand(selection);
Index: tmp/org.txm.core/src/java/org/txm/objects/EditionDefinition.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/EditionDefinition.java	(revision 2730)
+++ tmp/org.txm.core/src/java/org/txm/objects/EditionDefinition.java	(revision 2731)
@@ -11,29 +11,33 @@
  *
  */
 public class EditionDefinition {
-
+	
 	Preferences node;
+	
 	public EditionDefinition(Project project, String name) {
 		this.node = project.getPreferencesScope().getNode(EditionDefinition.class.getSimpleName()).node(name);
-		setName(name); //TODO use node.name() instead
+		setName(name); // TODO use node.name() instead
 	}
 	
-	public void delete() {
+	public boolean delete() {
 		try {
 			node.removeNode();
-		} catch (BackingStoreException e) {
+			return true;
+		}
+		catch (BackingStoreException e) {
 			e.printStackTrace();
+			return false;
 		}
 	}
-
+	
 	public String getName() {
-		return node.get(TBXPreferences.NAME, null);
+		return node.get(TBXPreferences.NAME, null); // should never return null
 	}
-
+	
 	public int getWordsPerPage() {
 		return node.getInt(TBXPreferences.EDITION_DEFINITION_WORDS_PER_PAGE, 500);
 	}
-
+	
 	public String getPageElement() {
 		return node.get(TBXPreferences.EDITION_DEFINITION_PAGE_BREAK_ELEMENT, "pb");
 	}
@@ -45,7 +49,7 @@
 	public String getImagesDirectory() {
 		return node.get(TBXPreferences.EDITION_DEFINITION_IMAGES_DIRECTORY, null);
 	}
-
+	
 	public void set(String key, String value) {
 		node.put(key, value);
 	}
@@ -53,34 +57,58 @@
 	public String get(String key) {
 		return node.get(key, null);
 	}
-
+	
+	public void copyParametersTo(EditionDefinition anotherEditionDefinition) {
+		anotherEditionDefinition.setPageBreakTag(this.getPageElement());
+		anotherEditionDefinition.setWordsPerPage(this.getWordsPerPage());
+		anotherEditionDefinition.setBuildEdition(this.getBuildEdition());
+		anotherEditionDefinition.setImagesDirectory(this.getImagesDirectory());
+	}
+	
 	public void setPageBreakTag(String page_break_tag) {
-		node.put(TBXPreferences.EDITION_DEFINITION_PAGE_BREAK_ELEMENT, page_break_tag);
+		if (page_break_tag == null) {
+			node.remove(TBXPreferences.EDITION_DEFINITION_PAGE_BREAK_ELEMENT);
+		}
+		else {
+			node.put(TBXPreferences.EDITION_DEFINITION_PAGE_BREAK_ELEMENT, page_break_tag);
+		}
 	}
-
+	
 	public void setWordsPerPage(int words_per_page) {
 		node.putInt(TBXPreferences.EDITION_DEFINITION_WORDS_PER_PAGE, words_per_page);
 	}
-
+	
 	public void setBuildEdition(boolean build) {
 		node.putBoolean(TBXPreferences.EDITION_DEFINITION_BUILD, build);
 	}
-
+	
 	public void setName(String name) {
-		node.put(TBXPreferences.NAME, name);
+		if (name == null) {
+			node.remove(TBXPreferences.NAME);
+		}
+		else {
+			node.put(TBXPreferences.NAME, name);
+		}
 	}
-
+	
 	public void setImagesDirectory(String images_directory) {
-		node.put(TBXPreferences.EDITION_DEFINITION_IMAGES_DIRECTORY, images_directory);
+		if (images_directory == null) {
+			node.remove(TBXPreferences.EDITION_DEFINITION_IMAGES_DIRECTORY);
+		}
+		else {
+			node.put(TBXPreferences.EDITION_DEFINITION_IMAGES_DIRECTORY, images_directory);
+		}
 	}
 	
+	@Override
 	public String toString() {
 		StringBuffer buffer = new StringBuffer();
 		try {
 			for (String k : node.keys()) {
-				buffer.append(k+"="+node.get(k, "")+"\t");
+				buffer.append(k + "=" + node.get(k, "") + "\t");
 			}
-		} catch (BackingStoreException e) {
+		}
+		catch (BackingStoreException e) {
 			// TODO Auto-generated catch block
 			e.printStackTrace();
 		}
Index: tmp/org.txm.core/src/java/org/txm/objects/Project.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Project.java	(revision 2730)
+++ tmp/org.txm.core/src/java/org/txm/objects/Project.java	(revision 2731)
@@ -771,10 +771,6 @@
 		return pDefaultEditionName != null;
 	}
 	
-	public String getDefaultEdition() {
-		return pDefaultEditionName;
-	}
-	
 	public List<String> getEditionNames() {
 		IEclipsePreferences node = this.getPreferencesScope().getNode(EditionDefinition.class.getSimpleName());
 		try {
Index: tmp/org.txm.core/src/java/org/txm/objects/Page.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Page.java	(revision 2730)
+++ tmp/org.txm.core/src/java/org/txm/objects/Page.java	(revision 2731)
@@ -43,40 +43,47 @@
  * The Class Page a fle to open in the Browser
  */
 public class Page {
-
+	
 	/** The htmlfile. */
-	File htmlfile;
+	protected File htmlfile;
 	
 	/** The edition. */
-	Edition edition;
+	protected Edition edition;
 	
 	/** The wordid. */
-	String firstWordId;
+	protected String firstWordId;
 	
-	String name;
-
+	protected String name;
+	
+	protected int idx;
+	
 	/**
 	 * Instantiates a new page.
 	 *
 	 * @param edition the edition
-	 * @param page the page
+	 * @param name the page name
+	 * @param wordid the page first word id
+	 * @param i the page position
+	 * 
 	 */
-	public Page(Edition edition, String name, String wordid) {
+	public Page(Edition edition, String name, String wordid, int i) {
 		this.edition = edition;
 		this.name = name;
 		this.firstWordId = wordid;
-		this.htmlfile = new File(edition.getHtmlDir(), edition.getText().getName()+"_"+name+".html");
+		this.htmlfile = new File(edition.getHtmlDir(), edition.getText().getName() + "_" + name + ".html");
+		this.idx = i;
 	}
 	
 	/**
 	 * Retro-compatibility of import.xml file
+	 * 
 	 * @param e
 	 */
 	public void _load(Element e) {
 		this.name = e.getAttribute("id");
 		this.firstWordId = e.getAttribute("wordid");
 	}
-
+	
 	/**
 	 * Gets the word id.
 	 *
@@ -85,7 +92,7 @@
 	public String getWordId() {
 		return firstWordId;
 	}
-
+	
 	/**
 	 * Gets the edition.
 	 *
@@ -94,7 +101,7 @@
 	public Edition getEdition() {
 		return edition;
 	}
-
+	
 	/**
 	 * Gets the file.
 	 *
@@ -103,7 +110,7 @@
 	public File getFile() {
 		return this.htmlfile;
 	}
-
+	
 	/**
 	 * To url.
 	 *
@@ -112,12 +119,13 @@
 	public String toURL() {
 		try {
 			return this.htmlfile.toURI().toURL().toString();
-		} catch (MalformedURLException e) {
+		}
+		catch (MalformedURLException e) {
 			System.err.println(NLS.bind(TXMCoreMessages.malformedURLFileP0, htmlfile));
 			return ""; //$NON-NLS-1$
 		}
 	}
-
+	
 	/**
 	 * Found first word id.
 	 *
@@ -128,10 +136,10 @@
 	public static String foundFirstWordId(File page) throws Exception {
 		InputStream inputData;
 		inputData = page.toURI().toURL().openStream();
-
+		
 		XMLInputFactory factory = XMLInputFactory.newInstance();
 		XMLStreamReader parser = factory.createXMLStreamReader(inputData);
-
+		
 		for (int event = parser.next(); event != XMLStreamConstants.END_DOCUMENT; event = parser.next()) {
 			if (event == XMLStreamConstants.START_ELEMENT) {
 				String localname = parser.getLocalName();
@@ -139,12 +147,12 @@
 				{
 					String idattr = parser.getAttributeValue(null, "id"); //$NON-NLS-1$
 					if (idattr != null)
-					if (idattr.startsWith("w")) //$NON-NLS-1$
-					{
+						if (idattr.startsWith("w")) //$NON-NLS-1$
+						{
 						parser.close();
 						inputData.close();
 						return idattr;
-					}
+						}
 				}
 			}
 		}
@@ -152,7 +160,7 @@
 		inputData.close();
 		return null;
 	}
-
+	
 	/**
 	 * Sets the name.
 	 *
@@ -170,16 +178,17 @@
 	public void setWordId(String wordid) {
 		this.firstWordId = wordid;
 	}
-
-	/* (non-Javadoc)
+	
+	/*
+	 * (non-Javadoc)
 	 * @see java.lang.Object#toString()
 	 */
 	@Override
 	public String toString() {
-		return "Page [name="+name+", htmlfile="+htmlfile +", firstWordId="+firstWordId+"]"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
+		return "Page [name=" + name + ", htmlfile=" + htmlfile + ", firstWordId=" + firstWordId + "]"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
 	}
-
+	
 	public String getName() {
 		return this.name;
 	}
-}
\ No newline at end of file
+}
Index: tmp/org.txm.core/src/java/org/txm/objects/Edition.java
===================================================================
--- tmp/org.txm.core/src/java/org/txm/objects/Edition.java	(revision 2730)
+++ tmp/org.txm.core/src/java/org/txm/objects/Edition.java	(revision 2731)
@@ -40,7 +40,6 @@
 import org.txm.core.results.Parameter;
 import org.txm.core.results.TXMParameters;
 import org.txm.core.results.TXMResult;
-import org.txm.utils.DeleteDir;
 import org.txm.utils.TXMProgressMonitor;
 import org.txm.utils.logger.Log;
 import org.w3c.dom.Element;
@@ -55,9 +54,6 @@
 	@Parameter(key = TBXPreferences.INDEX)
 	String pIndex;
 	
-	/** The pages. */
-	ArrayList<Page> pages = new ArrayList<>();
-	
 	@Parameter(key = TBXPreferences.NAMES)
 	ArrayList<String> pPageNames;
 	
@@ -108,7 +104,7 @@
 	 * @return the num pages
 	 */
 	public Integer getNumPages() {
-		return pages.size();
+		return pPageNames.size();
 	}
 	
 	/*
@@ -122,13 +118,25 @@
 		// System.out.println(" build edition "+name);
 		NodeList pagesList = e.getElementsByTagName("page"); //$NON-NLS-1$
 		int numpages = pagesList.getLength();
-		pages.clear();
+		if (pPageNames == null) {
+			pPageNames = new ArrayList<>();
+		}
+		else {
+			pPageNames.clear();
+		}
+		
+		if (pPageFirstWordIds == null) {
+			pPageFirstWordIds = new ArrayList<>();
+		}
+		else {
+			pPageFirstWordIds.clear();
+		}
+		
 		for (int i = 0; i < numpages; i++) {
 			Element p = (Element) pagesList.item(i);
-			Page page = new Page(this, "", "");
+			Page page = new Page(this, "", "", i);
 			page._load(p);
 			
-			pages.add(page);
 			pPageNames.add(page.getName());
 			pPageFirstWordIds.add(page.getWordId());
 		}
@@ -152,31 +160,10 @@
 		
 	}
 	
-	/**
-	 * Gets the pages.
-	 *
-	 * @return the pages
-	 */
-	public ArrayList<Page> getPages() {
-		return this.pages;
+	public int get(String id) {
+		return pPageNames.indexOf(id);
 	}
 	
-	public Page get(String id) {
-		int i = pPageNames.indexOf(id);
-		if (i < 0) return null;
-		return pages.get(i);
-	}
-	
-	/**
-	 * Gets the page.
-	 *
-	 * @param no the no
-	 * @return the page
-	 */
-	public Page getPage(int no) {
-		return pages.get(no);
-	}
-	
 	public static final Pattern findNumbersPattern = Pattern.compile("([0-9]{1,10}+)"); //$NON-NLS-1$
 	
 	/**
@@ -219,21 +206,24 @@
 	 */
 	public Page getPageForWordId(String idx) {
 		Log.fine("Page.getPageForWordId(): " + idx);
-		Page lastpage = null;
-		for (Page p : pages) {
-			String s = p.getWordId();
-			Log.fine(p.name + ": " + s + " >? " + idx);
+		int lastPage = 0;
+		
+		int i = 0;
+		for (String p : pPageNames) {
+			String s = pPageFirstWordIds.get(i);
+			Log.fine(p + ": " + s + " >? " + idx);
 			// if (getInt(s) > getInt(idx)) {
 			System.out.println();
 			if (isFirstGTthanSecond(s, idx) > 0) {
-				Log.fine("page found: " + lastpage);
-				return lastpage;
+				Log.fine("page found: " + lastPage);
+				return getPage(lastPage);
 			}
-			if (!("w_0".equals(p.getWordId()))) { // ignore the w_0 pages
-				lastpage = p;
+			if (!("w_0".equals(s))) { // ignore the w_0 pages
+				lastPage = i;
 			}
+			i++;
 		}
-		return lastpage;
+		return getPage(lastPage);
 	}
 	
 	public static int isFirstGTthanSecond(String s, String idx) {
@@ -285,20 +275,31 @@
 	 * @return the first page
 	 */
 	public Page getFirstPage() {
-		if (pages.size() > 0)
-			return pages.get(0);
-		return null;
+		return getPage(0);
 	}
 	
 	/**
+	 * Gets the page.
+	 *
+	 * @param no the no
+	 * @return the page
+	 */
+	public Page getPage(int n) {
+		if (n >= 0 && pPageNames.size() > n) {
+			return new Page(this, pPageNames.get(n), pPageFirstWordIds.get(n), n);
+		}
+		else {
+			return null;
+		}
+	}
+	
+	/**
 	 * Gets the last page.
 	 *
 	 * @return the last page
 	 */
 	public Page getLastPage() {
-		if (pages.size() > 0)
-			return pages.get(pages.size() - 1);
-		return null;
+		return getPage(pPageNames.size() - 1);
 	}
 	
 	/**
@@ -308,9 +309,9 @@
 	 * @return the next page
 	 */
 	public Page getNextPage(Page p) {
-		int idx = pages.indexOf(p);
-		if (idx < pages.size() - 1)
-			return pages.get(idx + 1);
+		int idx = p.idx;
+		if (idx < pPageNames.size() - 1)
+			return getPage(idx + 1);
 		return p;
 	}
 	
@@ -321,9 +322,9 @@
 	 * @return the previous page
 	 */
 	public Page getPreviousPage(Page p) {
-		int idx = pages.indexOf(p);
+		int idx = p.idx;
 		if (idx > 0)
-			return pages.get(idx - 1);
+			return getPage(idx - 1);
 		return p;
 	}
 	
@@ -344,7 +345,7 @@
 	public String toString() {
 		try {
 			return "Edition [name=" + userName + " index=" + pIndex + ", pages=" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
-					+ pages.size() + "]"; //$NON-NLS-1$
+					+ pPageNames.size() + "]"; //$NON-NLS-1$
 		}
 		catch (Exception e) {
 			return "Edition";
@@ -415,8 +416,8 @@
 	
 	@Override
 	public void clean() {
-		for (Page p : this.getPages()) {
-			p.getFile().delete();
+		for (String name : this.pPageNames) {
+			new File(this.getHtmlDir(), this.getText().getName() + "_" + name + ".html").delete();
 		}
 	}
 	
@@ -427,15 +428,15 @@
 	
 	@Override
 	protected boolean _compute(TXMProgressMonitor monitor) throws Exception {
-		// System.out.println("USE THE PROJECT IMPORTMODULE TO BUILD THE EDITION="+userName);
-		pages.clear();
-		
-		if (pages.size() != pPageNames.size()) {
-			for (int i = 0; i < pPageNames.size() && i < pPageFirstWordIds.size(); i++) {
-				pages.add(new Page(this, pPageNames.get(i), pPageFirstWordIds.get(i)));
-			}
-		}
-		
+		// // System.out.println("USE THE PROJECT IMPORTMODULE TO BUILD THE EDITION="+userName);
+		// pages.clear();
+		//
+		// if (pages.size() != pPageNames.size()) {
+		// for (int i = 0; i < pPageNames.size() && i < pPageFirstWordIds.size(); i++) {
+		// pages.add(new Page(this, pPageNames.get(i), pPageFirstWordIds.get(i)));
+		// }
+		// }
+		//
 		return true;
 	}
 	
@@ -456,4 +457,13 @@
 	public void setName(String name) {
 		this.userName = name;
 	}
+	
+	public ArrayList<String> getPageNames() {
+		return pPageNames;
+	}
+	
+	public Page getPageForName(String name) {
+		int i = pPageNames.indexOf(name);
+		return getPage(i);
+	}
 }
